# -*- coding: utf-8 -*-
import xbmc, xbmcgui, xbmcplugin
import sys, json
try:
    from urllib2 import urlopen
except ImportError:
    from urllib.request import urlopen
try:
    from urllib import urlencode, quote
except ImportError:
    from urllib.parse import urlencode, quote
try:
    from urlparse import urlparse, parse_qs
except ImportError:
    from urllib.parse import urlparse, parse_qs
import vod


def resp(ret, recur=False):
    if 'code' in ret:
        if 'error' in ret:
            return xbmcgui.Dialog().ok('Error: ' + ret['code'], ret['error'])
        return xbmcgui.Dialog().ok('Error', ret['code'])
    if isinstance(ret, list):
        xbmcplugin.setContent(handle, 'videos')
        for elem in ret:
            resp(elem, True)
        return xbmcplugin.endOfDirectory(handle)
    assert isinstance(ret, dict)
    if 'title' not in ret:
        for k, v in ret.items():
            if isinstance(v, list):
                ret = {'title': k, 'json': json.dumps(v)}
            else:
                ret = {'title': k, 'url': v}
    li = xbmcgui.ListItem(ret['title'])
    if 'img' in ret:
        li.setArt({'thumb': ret['img']})
    li.setInfo('video', ret)
    t = True
    if 'url' in ret:
        if isinstance(ret['url'], list):
            ret['url'] = 'stack://' + ' , '.join(ret['url'])
            if 'header' in ret:
                ret['url'] += '|' + urlencode(ret['header'])
            if recur:
                return xbmcplugin.addDirectoryItem(handle, ret['url'], li)
            return xbmc.Player().play(ret['url'], li)
        o = urlparse(ret['url'])
        p = o.path.split('/')
        ext = p[-1].split('.')[-1]
        if ext in ('m3u', 'm3u8'):
            if 'header' in ret:
                ret['url'] += '|' + urlencode(ret['header'])
            if recur:
                return xbmcplugin.addDirectoryItem(handle, ret['url'], li)
            return xbmc.Player().play(ret['url'], li)
        if t:
            t = sub1(ret['url'])
    for k, v in ret.items():
        try:
            ret[k] = v.encode('utf-8')
        except:
            pass
    xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode(ret), li, t)


def sub1(url):
    return True


def sub2(url):
    o = urlparse(url)
    q2 = parse_qs(o.query, True)
    s = False
    if 'search' in q and int(q['search'][0]):
        s = True
    if 'wd' in q2 and not q2['wd'][0]:
        s = search()
        if s:
            url += quote(s)
        else:
            return
    return resp(vod.entry(url, s))


def sub3(content):
    try:
        data = json.loads(content)
    except Exception as e:
        return resp({'code': 'vod 030', 'error': str(e)})
    data2 = []
    if isinstance(data, list):
        for e in data:
            if 'disabled' in e and e['disabled']:
                continue
            data2.append(e)
        data = data2
    resp(data)


def category(cat):
    if 'page' in q:
        page = int(q['page'][0])
    else:
        page = 1
    resp(vod.category(cat, page))


def search(s):
    if not s:
        kb = xbmc.Keyboard(heading='Search')
        kb.doModal()
        if not kb.isConfirmed():
            return
        s = kb.getText()
    if 'page' in q:
        page = int(q['page'][0])
    else:
        page = 1
    resp(vod.search(s, page))


def get_node(url):
    try:
        content = urlopen(url).read().decode('utf-8')
    except:
        content = json.dumps([])
    sub3(content)


handle = int(sys.argv[1])
para = sys.argv[2]
if not para:
    resp({'title': '电影', 'category': 'movie'})
    resp({'title': '电视剧', 'category': 'tv'})
    resp({'title': '综艺', 'category': 'variety'})
    resp({'title': '动漫', 'category': 'cartoon'})
    resp({'title': '纪录片', 'category': 'doc'})
    resp({'title': 'Search', 'search': ''})
    xbmcplugin.endOfDirectory(handle)
else:
    o = urlparse(para)
    q = parse_qs(o.query, True)
    if 'json' in q:
        sub3(q['json'][0])
    elif 'url' in q:
        sub2(q['url'][0])
    elif 'category' in q:
        category(q['category'][0])
    elif 'search' in q:
        search(q['search'][0])
